require "./web/examples.rb"
require "./lazylib.rb"
require "./run.rb"

def output(str)
  $output << str
end

pass = true

tests = ExamplesAndTests
tests.each{|name, prog, input, expected|
  $ReadStdin = str_to_lazy_list(input).const
  $ReadStdinLines = read_stdin_lines.const
  begin
    $output = ""
    run_and_do_io(prog,false,false)

    if $output != expected
      STDERR.puts "FAIL: #{name}"
      STDERR.puts prog
      STDERR.puts "expected:"
      STDERR.puts expected
      STDERR.puts "found:"
      STDERR.puts $output
      pass = false
    end
  rescue => e
    pass = false
    STDERR.puts "error in "+name
    raise e
  end
}

puts "PASS #{tests.size} examples" if pass
